//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using System.Globalization;
			using System.IO;
			using System;
			using System.Xml;
			
		#endregion
		
	public class LensConfigData : LensConfigReader, IBaseXmlWriter, IByteData
	
	{
		
		#region Fields
			private CultureInfo usCulture;
		#endregion
		
		#region Constructors
		
			public LensConfigData ()
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
			}
			
			
			public LensConfigData (byte[] pbPacketStream)
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
				int i1 = 0;
				int i2 = ArrayEx.ValueLength (pbPacketStream, i1, 256);
				base.m_byteLensName = new byte[i2];
				Array.Copy (((Array) pbPacketStream), i1, ((Array) base.m_byteLensName), 0, i2);
				i1 += 256;
				base.CalibrateFlag = BitConverter.ToBoolean (pbPacketStream, i1);
				i1++;
				base.KFactor = BitConverter.ToInt32 (pbPacketStream, i1);
				i1 += 4;
				base.ZKFactor = BitConverter.ToInt32 (pbPacketStream, i1);
				i1 += 4;
				base.FocalLength = BitConverter.ToInt32 (pbPacketStream, i1);
				i1 += 4;
				base.Aperture = BitConverter.ToInt32 (pbPacketStream, i1);
				i1 += 4;
				base.ZMode = BitConverter.ToInt16 (pbPacketStream, i1);
				i1 += 2;
				base.Table1XOffset = BitConverter.ToInt16 (pbPacketStream, i1);
				i1 += 2;
				base.Table1YOffset = BitConverter.ToInt16 (pbPacketStream, i1);
				i1 += 2;
				base.Table2XOffset = BitConverter.ToInt16 (pbPacketStream, i1);
				i1 += 2;
				base.Table2YOffset = BitConverter.ToInt16 (pbPacketStream, i1);
				i1 += 2;
				base.Table1XGain = BitConverter.ToSingle (pbPacketStream, i1);
				i1 += 4;
				base.Table1YGain = BitConverter.ToSingle (pbPacketStream, i1);
				i1 += 4;
				base.Table2XGain = BitConverter.ToSingle (pbPacketStream, i1);
				i1 += 4;
				base.Table2YGain = BitConverter.ToSingle (pbPacketStream, i1);
				i1 += 4;
				base.Table1Rotation = BitConverter.ToSingle (pbPacketStream, i1);
				i1 += 4;
				base.Table2Rotation = BitConverter.ToSingle (pbPacketStream, i1);
				i1 += 4;
			}
			
			
			public LensConfigData (string pstrPathFile)
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
				if ((pstrPathFile.Length > 0) && File.Exists (pstrPathFile))
				{
					this.FromFile (pstrPathFile);
				}
			}
			
		#endregion
		
		#region Methods
		
			public void Copy (object obj)
			
			{
				if ((obj == null) || (base.GetType () != obj.GetType ()))
				{
					return;
				}
				LensConfigData lensConfigData1 = ((LensConfigData) obj);
				base.Table1Rotation = lensConfigData1.Table1Rotation;
				base.Table2Rotation = lensConfigData1.Table2Rotation;
				base.Aperture = lensConfigData1.Aperture;
				base.ZMode = lensConfigData1.ZMode;
				base.CalibrateFlag = lensConfigData1.CalibrateFlag;
				base.Table1XGain = lensConfigData1.Table1XGain;
				base.Table1XOffset = lensConfigData1.Table1XOffset;
				base.Table1YGain = lensConfigData1.Table1YGain;
				base.Table1YOffset = lensConfigData1.Table1YOffset;
				base.FocalLength = lensConfigData1.FocalLength;
				base.KFactor = lensConfigData1.KFactor;
				base.LensName = lensConfigData1.LensName;
				base.Table2XGain = lensConfigData1.Table2XGain;
				base.Table2XOffset = lensConfigData1.Table2XOffset;
				base.Table2YGain = lensConfigData1.Table2YGain;
				base.Table2YOffset = lensConfigData1.Table2YOffset;
				base.ZKFactor = lensConfigData1.ZKFactor;
			}
			
			public static string FindLensFile (string pstrDisplayName, string pstrPath, string pstrSuggestedFile)
			
			{
				string string1;
				string string2;
				string string4;
				if ((pstrDisplayName.Length == 0) || (pstrPath.Length == 0))
				{
					return "";
				}
				if (pstrSuggestedFile.Length > 0)
				{
					string1 = Path.Combine (pstrPath, pstrSuggestedFile);
					if (Path.GetExtension (pstrSuggestedFile).Length == 0)
					{
						string1 = (string1 + ".txt");
					}
					if (File.Exists (string1))
					{
						string2 = LensConfigData.GetPrivateString (string1, "name");
						if (string2.CompareTo (pstrDisplayName) == 0)
						{
							return pstrSuggestedFile;
						}
					}
				}
				string[] stringArray1 = Directory.GetFiles (pstrPath, "*.txt");
				if (stringArray1.Length != 0)
				{
					foreach (string string3 in stringArray1)
					{
						string4 = LensConfigData.GetPrivateString (string3, "name");
						if (string4.CompareTo (pstrDisplayName) == 0)
						{
							return Path.GetFileName (string3);
						}
					}
				}
				return "";
			}
			
			public void FromFile (string pstrFileName)
			
			{
				string string1;
				int i1;
				string string2;
				string string3;
				StreamReader streamReader1 = ((StreamReader) null);
				try
				{
					streamReader1 = new StreamReader (pstrFileName);
					string1 = streamReader1.ReadLine ();
					
				L_00E4:
					
					{
					}
					if (string1 != null)
					{
						i1 = string1.IndexOf ('=');
						if (i1 >= 0)
						{
							string2 = string1.Substring (0, i1);
							string3 = string1.Substring (((int) (i1 + 1)));
							if (string2.CompareTo ("calfactor") == 0)
							{
								base.KFactor = Convert.ToInt32 (string3);
							}
							else if (string2.CompareTo ("zcalfactor") == 0)
							{
								base.ZKFactor = Convert.ToInt32 (string3);
							}
							else if (string2.CompareTo ("name") == 0)
							{
								base.LensName = string3;
							}
							else if (string2.CompareTo ("focallength") == 0)
							{
								base.FocalLength = Convert.ToInt32 (string3);
							}
							else if (string2.CompareTo ("aperture") == 0)
							{
								base.Aperture = Convert.ToInt32 (string3);
							}
							else if (string2.CompareTo ("3D") == 0)
							{
								base.ZMode = Convert.ToInt16 (string3);
							}
						}
						string1 = streamReader1.ReadLine ();
						goto L_00E4;
					}
					else
					{
						streamReader1.Close ();
					}
				}
				catch
				{
					if (streamReader1 != null)
					{
						streamReader1.Close ();
					}
				}
			}
			
			private static string GetPrivateString (string pstrPathFile, string pstrName)
			
			{
				StreamReader streamReader1;
				string string1;
				string string2;
				try
				{
					streamReader1 = new StreamReader (pstrPathFile);
					for (string1 = streamReader1.ReadLine (); (string1 != null); string1 = streamReader1.ReadLine ())
					{
						string2 = (pstrName + "0x03d");
						if (string1.IndexOf (string2) >= 0)
						{
							return string1.Substring (string2.Length);
						}
					}
					streamReader1.Close ();
				}
				catch
				{
				}
				return "";
			}
			
			public virtual byte[] ToBytes ()
			
			{
				byte[] byteArray1 = BitConverter.GetBytes (base.CalibrateFlag);
				byte[] byteArray2 = BitConverter.GetBytes (base.KFactor);
				byte[] byteArray3 = BitConverter.GetBytes (base.ZKFactor);
				byte[] byteArray4 = BitConverter.GetBytes (base.FocalLength);
				byte[] byteArray5 = BitConverter.GetBytes (base.Aperture);
				byte[] byteArray6 = BitConverter.GetBytes (base.ZMode);
				byte[] byteArray7 = BitConverter.GetBytes (base.Table1XOffset);
				byte[] byteArray8 = BitConverter.GetBytes (base.Table1YOffset);
				byte[] byteArray9 = BitConverter.GetBytes (base.Table2XOffset);
				byte[] byteArray10 = BitConverter.GetBytes (base.Table2YOffset);
				byte[] byteArray11 = BitConverter.GetBytes (base.Table1XGain);
				byte[] byteArray12 = BitConverter.GetBytes (base.Table1YGain);
				byte[] byteArray13 = BitConverter.GetBytes (base.Table2XGain);
				byte[] byteArray14 = BitConverter.GetBytes (base.Table2YGain);
				byte[] byteArray15 = BitConverter.GetBytes (base.Table1Rotation);
				byte[] byteArray16 = BitConverter.GetBytes (base.Table2Rotation);
				byte[] byteArray17 = new byte[((((((((((((((((256 + byteArray1.Length) + byteArray2.Length) + byteArray3.Length) + byteArray4.Length) + byteArray5.Length) + byteArray6.Length) + byteArray7.Length) + byteArray8.Length) + byteArray9.Length) + byteArray10.Length) + byteArray11.Length) + byteArray12.Length) + byteArray13.Length) + byteArray14.Length) + byteArray15.Length) + byteArray16.Length)];
				int i1 = 0;
				Array.Copy (((Array) base.m_byteLensName), 0, ((Array) byteArray17), i1, base.m_byteLensName.Length);
				i1 += 256;
				Array.Copy (((Array) byteArray1), 0, ((Array) byteArray17), i1, byteArray1.Length);
				i1 += byteArray1.Length;
				Array.Copy (((Array) byteArray2), 0, ((Array) byteArray17), i1, byteArray2.Length);
				i1 += byteArray2.Length;
				Array.Copy (((Array) byteArray3), 0, ((Array) byteArray17), i1, byteArray3.Length);
				i1 += byteArray3.Length;
				Array.Copy (((Array) byteArray4), 0, ((Array) byteArray17), i1, byteArray4.Length);
				i1 += byteArray4.Length;
				Array.Copy (((Array) byteArray5), 0, ((Array) byteArray17), i1, byteArray5.Length);
				i1 += byteArray5.Length;
				Array.Copy (((Array) byteArray6), 0, ((Array) byteArray17), i1, byteArray6.Length);
				i1 += byteArray6.Length;
				Array.Copy (((Array) byteArray7), 0, ((Array) byteArray17), i1, byteArray7.Length);
				i1 += byteArray7.Length;
				Array.Copy (((Array) byteArray8), 0, ((Array) byteArray17), i1, byteArray8.Length);
				i1 += byteArray8.Length;
				Array.Copy (((Array) byteArray9), 0, ((Array) byteArray17), i1, byteArray9.Length);
				i1 += byteArray9.Length;
				Array.Copy (((Array) byteArray10), 0, ((Array) byteArray17), i1, byteArray10.Length);
				i1 += byteArray10.Length;
				Array.Copy (((Array) byteArray11), 0, ((Array) byteArray17), i1, byteArray11.Length);
				i1 += byteArray11.Length;
				Array.Copy (((Array) byteArray12), 0, ((Array) byteArray17), i1, byteArray12.Length);
				i1 += byteArray12.Length;
				Array.Copy (((Array) byteArray13), 0, ((Array) byteArray17), i1, byteArray13.Length);
				i1 += byteArray13.Length;
				Array.Copy (((Array) byteArray14), 0, ((Array) byteArray17), i1, byteArray14.Length);
				i1 += byteArray14.Length;
				Array.Copy (((Array) byteArray15), 0, ((Array) byteArray17), i1, byteArray15.Length);
				i1 += byteArray15.Length;
				Array.Copy (((Array) byteArray16), 0, ((Array) byteArray17), i1, byteArray16.Length);
				i1 += byteArray16.Length;
				return byteArray17;
			}
			
			public void ToFile (string pstrFileName)
			
			{
				StreamWriter streamWriter1 = ((StreamWriter) null);
				try
				{
					streamWriter1 = new StreamWriter (pstrFileName, false);
					streamWriter1.WriteLine ("Copyright 0x0a9 2008 Lanmark Controls Inc.");
					streamWriter1.WriteLine ("Lens Correction File");
					streamWriter1.WriteLine (("Created " + DateTime.Now.ToShortDateString ()));
					streamWriter1.WriteLine ("");
					streamWriter1.WriteLine (("name0x03d" + base.LensName));
					streamWriter1.WriteLine (("aperture0x03d" + base.Aperture.ToString ()));
					streamWriter1.WriteLine (("focallength0x03d" + base.FocalLength.ToString ()));
					streamWriter1.WriteLine (("calfactor0x03d" + base.KFactor.ToString ()));
					streamWriter1.WriteLine (("zcalfactor0x03d" + base.ZKFactor.ToString ()));
					streamWriter1.WriteLine (("3D0x03d" + base.ZMode.ToString ()));
					streamWriter1.Close ();
				}
				catch
				{
					if (streamWriter1 != null)
					{
						streamWriter1.Close ();
					}
				}
			}
			
			public virtual string ToXML ()
			
			{
				return XmlHelper.ToXML (this, uint.MinValue, false);
			}
			
			public virtual string ToXML (uint puiTabIndent)
			
			{
				return XmlHelper.ToXML (this, puiTabIndent, false);
			}
			
			public virtual void ToXML (XmlTextWriter poWrite, uint puiTabIndent)
			
			{
				string string1 = XmlHelper.Indent (puiTabIndent);
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				poWrite.WriteElementString ("LensName", base.LensName);
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				bool b1 = base.CalibrateFlag;
				poWrite.WriteElementString ("CalFlag", b1.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				int i1 = base.KFactor;
				poWrite.WriteElementString ("KFactor", i1.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				int i2 = base.ZKFactor;
				poWrite.WriteElementString ("ZKFactor", i2.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				int i3 = base.FocalLength;
				poWrite.WriteElementString ("FocalLen", i3.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				int i4 = base.Aperture;
				poWrite.WriteElementString ("Aperture", i4.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_1 = base.ZMode;
				poWrite.WriteElementString ("ZMode", int16_1.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_2 = base.Table1XOffset;
				poWrite.WriteElementString ("Tbl1XOff", int16_2.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_3 = base.Table1YOffset;
				poWrite.WriteElementString ("Tbl1YOff", int16_3.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_4 = base.Table2XOffset;
				poWrite.WriteElementString ("Tbl2XOff", int16_4.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_5 = base.Table2YOffset;
				poWrite.WriteElementString ("Tbl2YOff", int16_5.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				float single1 = base.Table1XGain;
				poWrite.WriteElementString ("Tbl1XGain", single1.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				float single2 = base.Table1YGain;
				poWrite.WriteElementString ("Tbl1YGain", single2.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				float single3 = base.Table2XGain;
				poWrite.WriteElementString ("Tbl2XGain", single3.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				float single4 = base.Table2YGain;
				poWrite.WriteElementString ("Tbl2YGain", single4.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				float single5 = base.Table1Rotation;
				poWrite.WriteElementString ("Tbl1Rotation", single5.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				float single6 = base.Table2Rotation;
				poWrite.WriteElementString ("Tbl2Rotation", single6.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1));
			}
			
			public virtual string ToXMLFooter ()
			
			{
				return XmlHelper.ToXMLFooter (this);
			}
			
			public virtual void ToXMLFooter (XmlTextWriter poWrite)
			
			{
				XmlHelper.ToXMLFooter (poWrite);
			}
			
			public virtual void ToXMLHeader (XmlTextWriter poWrite)
			
			{
				XmlHelper.ToXMLHeader (poWrite, this.Type, this.Version);
			}
			
			public virtual string ToXMLHeader ()
			
			{
				return XmlHelper.ToXMLHeader (this);
			}
			
		#endregion
	}
	
}

