//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using System.Collections.Generic;
			using System.Globalization;
			using System.IO;
			using System;
			using System.Xml;
			
		#endregion
		
	public class PerformanceMatrixData : BaseConfig, IBaseXmlReader, IBaseXmlWriter
	
	{
		
		#region Fields
			private UInt16 m_Orientation;
			private double m_sLaserPower;
			private double m_sLaserPowerComp;
			private double m_sMarkSpeed;
			private double m_sPeriod;
			private double m_sPulseWidth;
			private string m_strDefaultFileName;
			private static readonly string m_strDisplayName;
			private string m_strType;
			private string m_strVersion;
			private short m_sXOffset;
			private short m_sYOffset;
			private short m_sZOffset;
			public const uint Opcode = 16;
			private CultureInfo usCulture;
		#endregion
		
		#region Constructors
		
			public PerformanceMatrixData ()
			
			{
				this.usCulture = new CultureInfo ("en-US", false);
				this.m_strDefaultFileName = "GlobalConfig.xml";
				this.m_strVersion = "1.0";
				this.m_sMarkSpeed = 1D;
				this.m_sLaserPower = 1D;
				this.m_sLaserPowerComp = 1D;
				this.m_sPulseWidth = 1D;
				this.m_sPeriod = 1D;
				this.m_strType = "PerformanceMatrixData";
			}
			
			
			static PerformanceMatrixData ()
			
			{
				PerformanceMatrixData.m_strDisplayName = "Performance Matrix Information";
			}
			
		#endregion
		
		#region Properties
		
			public override string DefaultFileName
			
			{
				get
				{
					return this.m_strDefaultFileName;
				}
			}
			
			
			public static string DisplayName
			
			{
				get
				{
					return PerformanceMatrixData.m_strDisplayName;
				}
			}
			
			
			public UInt16 FieldOrientation
			
			{
				get
				{
					return this.m_Orientation;
				}
				set
				{
					this.m_Orientation = value;
				}
			}
			
			
			public double LaserPowerCompPercent
			
			{
				get
				{
					return this.m_sLaserPowerComp;
				}
				set
				{
					this.m_sLaserPowerComp = value;
				}
			}
			
			
			public double LaserPowerPercent
			
			{
				get
				{
					return this.m_sLaserPower;
				}
				set
				{
					this.m_sLaserPower = value;
				}
			}
			
			
			public double MarkSpeedPercent
			
			{
				get
				{
					return this.m_sMarkSpeed;
				}
				set
				{
					this.m_sMarkSpeed = value;
				}
			}
			
			
			public double PeriodPercent
			
			{
				get
				{
					return this.m_sPeriod;
				}
				set
				{
					this.m_sPeriod = value;
				}
			}
			
			
			public double PulseWidthPercent
			
			{
				get
				{
					return this.m_sPulseWidth;
				}
				set
				{
					this.m_sPulseWidth = value;
				}
			}
			
			
			public override string Type
			
			{
				get
				{
					return this.m_strType;
				}
			}
			
			
			public override string Version
			
			{
				get
				{
					return this.m_strVersion;
				}
			}
			
			
			public short XOffset
			
			{
				get
				{
					return this.m_sXOffset;
				}
				set
				{
					this.m_sXOffset = value;
				}
			}
			
			
			public short YOffset
			
			{
				get
				{
					return this.m_sYOffset;
				}
				set
				{
					this.m_sYOffset = value;
				}
			}
			
			
			public short ZOffset
			
			{
				get
				{
					return this.m_sZOffset;
				}
				set
				{
					this.m_sZOffset = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void FromXML (XmlTextReader pxmlRead)
			
			{
				string string1;
				int i1;
				Dictionary<String, Int32> dictionary21 = ((Dictionary<String, Int32>) null);
				while (true)
				{
					while (pxmlRead.NodeType == XmlNodeType.Element)
					{
						if ((string1 = pxmlRead.Name) != null)
						{
							if (dictionary21 == null)
							{
								dictionary21 = new Dictionary<String, Int32> (8);
								dictionary21.Add ("MarkSpeed", 0);
								dictionary21.Add ("XOffset", 1);
								dictionary21.Add ("YOffset", 2);
								dictionary21.Add ("ZOffset", 3);
								dictionary21.Add ("LaserPower", 4);
								dictionary21.Add ("LaserPowerComp", 5);
								dictionary21.Add ("PulseWidth", 6);
								dictionary21.Add ("Period", 7);
							}
							if (dictionary21.TryGetValue (string1, out i1))
							{
								switch (i1)
								{
									case 0:
									
									{
											bool b1 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.MarkSpeedPercent = Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 1:
									
									{
											bool b2 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.XOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 2:
									
									{
											bool b3 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.YOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 3:
									
									{
											bool b4 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.ZOffset = Convert.ToInt16 (pxmlRead.Value);
											continue;
									}
									case 4:
									
									{
											bool b5 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserPowerPercent = Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 5:
									
									{
											bool b6 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.LaserPowerCompPercent = Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 6:
									
									{
											bool b7 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.PulseWidthPercent = Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
									case 7:
									
									{
											bool b8 = pxmlRead.Read ();
											if (pxmlRead.NodeType != XmlNodeType.Text)
											{
												continue;
											}
											this.PeriodPercent = Convert.ToDouble (pxmlRead.Value, ((IFormatProvider) this.usCulture));
											continue;
									}
								}
							}
						}
						bool b9 = pxmlRead.Read ();
					}
					if (! pxmlRead.Read ())
					{
						return;
					}
				}
			}
			
			public virtual void FromXML (string pstrData)
			
			{
				if (pstrData.Length == 0)
				{
					return;
				}
				StringReader stringReader1 = new StringReader (pstrData);
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
			}
			
			public virtual void FromXML (StreamReader poData)
			
			{
				XmlTextReader xmlTextReader1 = new XmlTextReader (((TextReader) poData));
				this.FromXML (xmlTextReader1);
				xmlTextReader1.Close ();
			}
			
			public virtual void ToXML (XmlTextWriter poWrite, uint puiTabIndent)
			
			{
				string string1 = XmlHelper.Indent (puiTabIndent);
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				double double1 = this.LaserPowerPercent;
				poWrite.WriteElementString ("LaserPower", double1.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				double double2 = this.LaserPowerCompPercent;
				poWrite.WriteElementString ("LaserPowerComp", double2.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				double double3 = this.PeriodPercent;
				poWrite.WriteElementString ("Period", double3.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				double double4 = this.PulseWidthPercent;
				poWrite.WriteElementString ("PulseWidth", double4.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				double double5 = this.MarkSpeedPercent;
				poWrite.WriteElementString ("MarkSpeed", double5.ToString (((IFormatProvider) this.usCulture)));
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_1 = this.XOffset;
				poWrite.WriteElementString ("XOffset", int16_1.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_2 = this.YOffset;
				poWrite.WriteElementString ("YOffset", int16_2.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1 + "\t"));
				short int16_3 = this.ZOffset;
				poWrite.WriteElementString ("ZOffset", int16_3.ToString ());
				poWrite.WriteWhitespace (("\r\n" + string1));
			}
			
			public virtual string ToXML (uint puiTabIndent)
			
			{
				return XmlHelper.ToXML (this, puiTabIndent, false);
			}
			
			public virtual string ToXML ()
			
			{
				return XmlHelper.ToXML (this, uint.MinValue, false);
			}
			
			public virtual string ToXMLFooter ()
			
			{
				return XmlHelper.ToXMLFooter (this);
			}
			
			public virtual void ToXMLFooter (XmlTextWriter poWrite)
			
			{
				XmlHelper.ToXMLFooter (poWrite);
			}
			
			public virtual string ToXMLHeader ()
			
			{
				return XmlHelper.ToXMLHeader (this);
			}
			
			public virtual void ToXMLHeader (XmlTextWriter poWrite)
			
			{
				XmlHelper.ToXMLHeader (poWrite, this.Type, this.Version);
			}
			
		#endregion
	}
	
}

