//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:10:35
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Threading

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using System;
			using System.Threading;
			
		#endregion
		
	public class BaseThread
	
	{
		
		#region Fields
			private AutoResetEvent childNotifyEvent;
			private bool m_bIsThreadRunning;
			private bool m_bShutdown;
			private int m_iChildTerminateWait;
			private ManualResetEvent mainNotifyEvent;
		#endregion
		
		#region Constructors
		
			public BaseThread ()
			
			{
				this.m_iChildTerminateWait = 2000;
				this.mainNotifyEvent = new ManualResetEvent (false);
				this.childNotifyEvent = new AutoResetEvent (false);
			}
			
		#endregion
		
		#region Properties
		
			protected int ChildTerminateWait
			
			{
				get
				{
					return this.m_iChildTerminateWait;
				}
				set
				{
					this.m_iChildTerminateWait = value;
				}
			}
			
			
			public bool IsThreadRunning
			
			{
				get
				{
					return this.m_bIsThreadRunning;
				}
				set
				{
					this.m_bIsThreadRunning = value;
				}
			}
			
			
			public bool LogConsole
			
			{
				get
				{
					return Logging.Instance.LogConsole;
				}
				set
				{
					Logging.Instance.LogConsole = value;
				}
			}
			
			
			public string LogFile
			
			{
				get
				{
					return Logging.Instance.LogFile;
				}
				set
				{
					Logging.Instance.LogFile = value;
				}
			}
			
			
			public int LoggingLevel
			
			{
				get
				{
					return Logging.Instance.LoggingLevel;
				}
				set
				{
					Logging.Instance.LoggingLevel = value;
				}
			}
			
			
			public bool Shutdown
			
			{
				get
				{
					return this.m_bShutdown;
				}
				set
				{
					this.m_bShutdown = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			protected virtual bool ExecuteWorkThread ()
			
			{
				return true;
			}
			
			protected virtual bool InitializeWorkThread ()
			
			{
				return true;
			}
			
			public bool InterruptThread ()
			
			{
				this.InterruptWorkThread (false);
				return true;
			}
			
			protected virtual void InterruptWorkThread (bool pbAbort)
			
			{
			}
			
			public bool StartThread ()
			
			{
				Exception exception1;
				bool b1 = false;
				try
				{
					b1 = this.IsThreadRunning;
					if (b1)
					{
						return true;
					}
					else
					{
						bool b3 = this.mainNotifyEvent.Reset ();
						Logging.Instance.Log ((this.ToString () + ".BaseThread.StartThread() - mainNotifyEvent reset."));
						if (ThreadPool.QueueUserWorkItem (new WaitCallback (this.WorkThread)))
						{
							bool b4 = this.mainNotifyEvent.WaitOne ();
							Logging.Instance.Log ((this.ToString () + ".BaseThread.StartThread() - mainNotifyEvent detected."));
						}
						else
						{
							return false;
						}
						b1 = this.IsThreadRunning;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, (this.ToString () + ".BaseThread.StartThread() - An Exception was detected - " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return b1;
			}
			
			public bool StopThread ()
			
			{
				Exception exception1;
				try
				{
					int i1 = this.mainNotifyEvent.Handle.ToInt32 ();
					bool b1 = this.mainNotifyEvent.Reset ();
					Logging.Instance.Log ((this.ToString () + ".BaseThread.StopThread() - mainNotifyEvent reset."));
					this.InterruptWorkThread (true);
					bool b2 = this.childNotifyEvent.Set ();
					bool b3 = this.mainNotifyEvent.WaitOne ();
					Logging.Instance.Log ((this.ToString () + ".BaseThread.StopThread() - mainNotifyEvent detected."));
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, (this.ToString () + ".BaseThread.StopThread() - An Exception was detected - " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				Logging.Instance.Dispose ();
				return true;
			}
			
			protected virtual bool TerminateWorkThread ()
			
			{
				return true;
			}
			
			private void WorkThread (object stateInfo)
			
			{
				Exception exception1;
				Exception exception2;
				this.IsThreadRunning = true;
				if (! this.InitializeWorkThread ())
				{
					this.IsThreadRunning = false;
					if (this.mainNotifyEvent.Handle.ToInt32 () != -1)
					{
						bool b1 = this.mainNotifyEvent.Set ();
						Logging.Instance.Log ((this.ToString () + ".BaseThread.StartThread() - mainNotifyEvent sent."));
					}
					return;
				}
				if (this.mainNotifyEvent.Handle.ToInt32 () != -1)
				{
					bool b2 = this.mainNotifyEvent.Set ();
					Logging.Instance.Log ((this.ToString () + ".BaseThread.StartThread() - mainNotifyEvent sent."));
				}
				this.Shutdown = false;
				try
				{
					while (! this.Shutdown)
					{
						this.Shutdown = this.childNotifyEvent.WaitOne (this.ChildTerminateWait, false);
						if (! this.Shutdown)
						{
							this.Shutdown = (! this.ExecuteWorkThread ());
						}
					}
					Logging.Instance.Log ((this.ToString () + ".BaseThread.WorkThread() - Connection shutdown begin."));
					bool b3 = this.TerminateWorkThread ();
					Logging.Instance.Log ((this.ToString () + ".BaseThread.WorkThread() - Terminate worker thread called."));
				}
				catch (Exception exception3)
				{
					exception1 = exception3;
					Logging.Instance.Log (0, (this.ToString () + ".BaseThread.WorkThread() - Exception occurred - " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				BaseThread baseThread1 = this;
				lock (baseThread1)
				{
					try
					{
						Logging.Instance.Log ((this.ToString () + ".BaseThread.WorkThread() - Begin signal to parent."));
						if (this.mainNotifyEvent.Handle.ToInt32 () != -1)
						{
							int i1 = this.mainNotifyEvent.Handle.ToInt32 ();
							bool b4 = this.mainNotifyEvent.Set ();
							Logging.Instance.Log ((this.ToString () + ".BaseThread.WorkThread() - mainNotifyEvent sent."));
						}
						this.IsThreadRunning = false;
						Logging.Instance.Log ((this.ToString () + ".BaseThread.WorkThread() - IsThreadRunning set to false."));
						Logging.Instance.Log ((this.ToString () + ".BaseThread.WorkThread() - Connection shutdown end."));
					}
					catch (Exception exception4)
					{
						exception2 = exception4;
						Logging.Instance.Log (0, (this.ToString () + ".BaseThread.WorkThread() - Exception thrown."));
						Logging.Instance.Log (0, exception2.ToString ());
						this.IsThreadRunning = false;
					}
				}
			}
			
		#endregion
	}
	
}

