//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:22:12
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.FTP

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Collections.Generic;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Text;
			
		#endregion
		
	public class FtpConnection
	
	{
		
		#region Fields
			private ASCIIEncoding ASCII;
			private Socket clientSocket;
			public event CommandCompletedHandler CommandCompleted;
			public event CommandSentHandler CommandSent;
			public event ConnectedHandler Connected;
			public event ConnectionFailedHandler ConnectionFailed;
			private DataConnection dataSocket;
			public event DisconnectedHandler Disconnected;
			private bool isNowConnected;
			private string lastResponse;
			private short lastResponseNumber;
			private short lastResponseType;
			private string localIPAddress;
			private string logonName;
			private string logonPass;
			public event NewDirectoryListingHandler NewDirectoryListing;
			private IPEndPoint passiveEndPoint;
			private bool passiveTransfers;
			public event ReceivedReplyHandler ReceivedReply;
			private string remoteAddress;
			private string remoteDirectory;
			private int remoteFileCount;
			private FileItem[] remoteFiles;
			private int remotePort;
		#endregion
		
		#region Nested Types
		
			public delegate void CommandCompletedHandler ();
			
			public delegate void CommandSentHandler (string Command);
			
			public delegate void ConnectedHandler ();
			
			public delegate void ConnectionFailedHandler ();
			
			public delegate void DisconnectedHandler ();
			
			public delegate void NewDirectoryListingHandler ();
			
			public delegate void ReceivedReplyHandler (string Reply, short ReplyNumber, short ReplyType);
			
			public enum StreamModes
			
			{
				ASCII = 65, 
				Binary = 73, 
			}
			
		#endregion
		
		#region Constructors
		
			public FtpConnection ()
			
			{
				this.localIPAddress = "";
				this.remotePort = 21;
				this.remoteAddress = "";
				this.logonName = "anonymous";
				this.logonPass = "user@";
				this.ASCII = new ASCIIEncoding ();
				this.lastResponse = "";
				this.remoteDirectory = "";
			}
			
		#endregion
		
		#region Properties
		
			public string Hostname
			
			{
				get
				{
					return this.remoteAddress;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.remoteAddress = value;
					}
				}
			}
			
			
			public bool IsConnected
			
			{
				get
				{
					return this.isNowConnected;
				}
			}
			
			
			public string LocalIPAddress
			
			{
				get
				{
					return this.localIPAddress;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.localIPAddress = value;
					}
				}
			}
			
			
			public bool Passive
			
			{
				get
				{
					return this.passiveTransfers;
				}
				set
				{
					this.passiveTransfers = value;
				}
			}
			
			
			public string Password
			
			{
				get
				{
					return this.logonPass;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.logonPass = value;
					}
				}
			}
			
			
			public int Port
			
			{
				get
				{
					return this.remotePort;
				}
				set
				{
					this.remotePort = value;
				}
			}
			
			
			public string Username
			
			{
				get
				{
					return this.logonName;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else
					{
						this.logonName = value;
					}
				}
			}
			
			
			public string WorkDir
			
			{
				get
				{
					return this.remoteDirectory;
				}
				set
				{
					if (value == null)
					{
						throw new ArgumentNullException ();
					}
					else if (this.IsConnected)
					{
						if (! this.remoteDirectory.Equals (value))
						{
							this.ChangeWorkDir (value);
						}
						else
						{
							this.remoteDirectory = value;
						}
					}
				}
			}
			
		#endregion
		
		#region Methods
		
			public void Abort ()
			
			{
				if (this.IsConnected)
				{
					this.SendCommand ("ABOR");
					this.OnCommandCompleted ();
				}
			}
			
			public void ChangeToUpDir ()
			
			{
				if (this.IsConnected)
				{
					this.SendCommand ("CDUP");
					this.OnCommandCompleted ();
				}
			}
			
			public void ChangeWorkDir (string NewDirectory)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("CWD " + NewDirectory));
					this.PrintWorkDir ();
				}
			}
			
			public void ChMod (string Filename, string NewMode)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("SITE chmod " + NewMode + " " + Filename));
					this.OnCommandCompleted ();
				}
			}
			
			public void Connect ()
			
			{
				IPAddress iPAddress1;
				IPEndPoint iPEndPoint1;
				try
				{
					this.clientSocket = new Socket (AddressFamily.Unspecified, SocketType.Stream, ProtocolType.Tcp);
					iPAddress1 = IPAddress.Parse (this.LocalIPAddress);
					if ((iPAddress1.ToString () == "0.0.0.0") || (iPAddress1.ToString () == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (iPAddress1, 0);
					}
					this.clientSocket.Bind (((EndPoint) iPEndPoint1));
					this.clientSocket.Connect (((EndPoint) new IPEndPoint (Dns.Resolve (this.remoteAddress).AddressList[0], this.remotePort)));
					this.isNowConnected = true;
					this.OnConnected ();
				}
				catch
				{
					this.isNowConnected = false;
					this.OnConnectionFailed ();
					return;
				}
				this.WaitForResponse ();
				this.SendCommand (("USER " + this.logonName));
				if ((this.lastResponseType == 4) || (this.lastResponseType == 5))
				{
					this.isNowConnected = false;
				}
				else
				{
					this.SendCommand (("PASS " + this.logonPass));
					if ((this.lastResponseType == 4) || (this.lastResponseType == 5))
					{
						this.isNowConnected = false;
					}
					else
					{
						switch (this.remoteDirectory)
						{
							case "":
							
							{
									this.PrintWorkDir ();
									return;
							}
							default:
							
							{
									this.ChangeWorkDir (this.remoteDirectory);
									return;
							}
						}
					}
				}
			}
			
			private bool CreateDataSocket (string Filename, DataConnection.FileModes Filemode, DataConnection.StreamDirections StreamDirection, long AppendFrom)
			
			{
				int i1;
				int i2;
				string[] stringArray1;
				char[] charArray1;
				string[] stringArray2;
				try
				{
					this.dataSocket = new DataConnection ();
					this.dataSocket.LocalIPAddress = this.LocalIPAddress;
					this.dataSocket.Filename = Filename;
					this.dataSocket.DownloadToFile = (Filename != "");
					this.dataSocket.AppendFrom = AppendFrom;
					this.dataSocket.FileMode = Filemode;
					this.dataSocket.StreamDirection = StreamDirection;
					this.dataSocket.DataSent += new DataConnection.DataSentHandler (this.DataSent);
					this.dataSocket.DataReceived += new DataConnection.DataReceivedHandler (this.DataReceived);
					if (this.passiveTransfers)
					{
						this.SendCommand ("PASV");
						if (this.lastResponseType == 2)
						{
							i1 = this.lastResponse.IndexOf ("(");
							i2 = this.lastResponse.IndexOf (")", ((int) (i1 + 1)));
							if ((i1 > 0) && (i2 > 0))
							{
								charArray1 = new char[] { '\u002C' };
								stringArray1 = this.lastResponse.Substring (((int) (i1 + 1)), ((int) ((i2 - i1) - 1))).Split (charArray1);
								if (stringArray1.Length == 6)
								{
									stringArray2 = new string[] { stringArray1[0], ".", stringArray1[1], ".", stringArray1[2], ".", stringArray1[3] };
									this.passiveEndPoint = new IPEndPoint (IPAddress.Parse (string.Concat (stringArray2)), ((int) ((int.Parse (stringArray1[4]) * 256) + int.Parse (stringArray1[5]))));
									this.dataSocket.RemoteEndPoint = this.passiveEndPoint;
									this.dataSocket.Connect ();
								}
							}
						}
					}
					else
					{
						this.dataSocket.Listen ();
					}
				}
				catch
				{
					return false;
				}
				return true;
			}
			
			private bool CreateDataSocket (DataConnection.StreamDirections StreamDirection)
			
			{
				return this.CreateDataSocket ("", DataConnection.FileModes.Overwrite, StreamDirection, 0L);
			}
			
			public void CustomCommand (string Command)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (Command);
					this.OnCommandCompleted ();
				}
			}
			
			private void DataReceived (int BytesLength)
			
			{
			}
			
			private void DataSent (int BytesLength)
			
			{
			}
			
			public void Delete (string Filename)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("DELE " + Filename));
					this.OnCommandCompleted ();
				}
			}
			
			public void DeleteDirectory (string directoryName)
			
			{
				int i1;
				int i2;
				string string1 = this.WorkDir;
				this.ChangeWorkDir (directoryName);
				string string2 = (string1 + "/" + directoryName);
				if (string2.CompareTo (this.WorkDir) != 0)
				{
					return;
				}
				string string3 = this.WorkDir;
				bool b1 = this.GetList ();
				FileItem[] fileItemArray1 = this.GetDirectoryListing ();
				if (fileItemArray1 != null)
				{
					for (i1 = 0; (i1 < fileItemArray1.Length); i1++)
					{
						if (fileItemArray1[i1].IsDirectory)
						{
							this.DeleteDirectory (fileItemArray1[i1].FileTitle);
						}
					}
					string string4 = this.WorkDir;
					for (i2 = 0; (i2 < fileItemArray1.Length); i2++)
					{
						if (! fileItemArray1[i2].IsDirectory)
						{
							this.Delete (fileItemArray1[i2].FileTitle);
						}
					}
				}
				this.ChangeWorkDir ("..");
				string string5 = this.WorkDir;
				this.RemoveDir (directoryName);
			}
			
			public void Disconnect ()
			
			{
				if (this.isNowConnected)
				{
					this.SendCommand ("QUIT");
					try
					{
						this.clientSocket.Shutdown (SocketShutdown.Both);
					}
					finally
					{
						this.clientSocket.Close ();
						this.isNowConnected = false;
					}
					this.OnDisconnected ();
				}
			}
			
			public bool DownloadFile (string RemoteFile, string LocalFile)
			
			{
				return this.DownloadFile (RemoteFile, LocalFile, StreamModes.Binary, DataConnection.FileModes.Overwrite, 0L);
			}
			
			public bool DownloadFile (string RemoteFile, string LocalFile, DataConnection.FileModes FileMode, long AppendFrom)
			
			{
				return this.DownloadFile (RemoteFile, LocalFile, StreamModes.Binary, DataConnection.FileModes.Overwrite, AppendFrom);
			}
			
			public bool DownloadFile (string RemoteFile, string LocalFile, StreamModes StreamMode)
			
			{
				return this.DownloadFile (RemoteFile, LocalFile, StreamMode, DataConnection.FileModes.Overwrite, 0L);
			}
			
			public bool DownloadFile (string RemoteFile, string LocalFile, StreamModes StreamMode, DataConnection.FileModes FileMode, long AppendFrom)
			
			{
				IPEndPoint iPEndPoint1;
				string[] stringArray1;
				this.SendCommand (("TYPE " + Convert.ToChar (StreamMode).ToString ()));
				if (! this.CreateDataSocket (LocalFile, FileMode, DataConnection.StreamDirections.Download, AppendFrom))
				{
					this.OnCommandCompleted ();
					return false;
				}
				else
				{
					if (! this.passiveTransfers)
					{
						iPEndPoint1 = this.dataSocket.GetLocalEndPoint;
						stringArray1 = new string[] { "PORT ", iPEndPoint1.Address.ToString ().Replace (".", ","), ",", ((int) Math.Floor (((double) (iPEndPoint1.Port / 256)))).ToString (), ",", (iPEndPoint1.Port % 256).ToString () };
						this.SendCommand (string.Concat (stringArray1));
					}
					if ((FileMode == DataConnection.FileModes.Append) && (AppendFrom > ((long) 0)))
					{
						this.SendCommand (("REST " + AppendFrom.ToString ()));
					}
					this.SendCommand (("RETR " + RemoteFile));
					if ((this.lastResponseType != 4) && (this.lastResponseType != 5))
					{
						try
						{
							this.dataSocket.ReceiveFromSocket ();
						}
						catch
						{
							this.dataSocket.Close ();
							this.WaitForResponse ();
							this.OnCommandCompleted ();
							return false;
						}
						this.WaitForResponse ();
					}
					this.dataSocket.Close ();
					this.OnCommandCompleted ();
					if (this.lastResponseType == 4)
					{
						return false;
					}
					else
					{
						return (this.lastResponseType != 5);
					}
				}
			}
			
			public int GetDirectoryListCount ()
			
			{
				return this.remoteFileCount;
			}
			
			public FileItem[] GetDirectoryListing ()
			
			{
				return this.remoteFiles;
			}
			
			public string GetLastResponse ()
			
			{
				return this.lastResponse;
			}
			
			public short GetLastResponseNumber ()
			
			{
				return this.lastResponseNumber;
			}
			
			public bool GetList ()
			
			{
				IPEndPoint iPEndPoint1;
				string[] stringArray1;
				if (! this.IsConnected)
				{
					return false;
				}
				else
				{
					this.SendCommand ("TYPE A");
					if (! this.CreateDataSocket (DataConnection.StreamDirections.Download))
					{
						this.OnCommandCompleted ();
						return false;
					}
					else
					{
						if (! this.passiveTransfers)
						{
							iPEndPoint1 = this.dataSocket.GetLocalEndPoint;
							stringArray1 = new string[] { "PORT ", iPEndPoint1.Address.ToString ().Replace (".", ","), ",", ((int) Math.Floor (((double) (iPEndPoint1.Port / 256)))).ToString (), ",", (iPEndPoint1.Port % 256).ToString () };
							this.SendCommand (string.Concat (stringArray1));
						}
						this.SendCommand ("LIST");
						if ((this.lastResponseType != 4) && (this.lastResponseType != 5))
						{
							try
							{
								this.dataSocket.ReceiveFromSocket ();
							}
							catch
							{
								this.dataSocket.Close ();
								this.WaitForResponse ();
								this.OnCommandCompleted ();
								return false;
							}
							this.WaitForResponse ();
						}
						this.ParseDirList (this.dataSocket.Data);
						this.dataSocket.Close ();
						this.OnNewDirectoryListing ();
						this.OnCommandCompleted ();
						return true;
					}
				}
			}
			
			public void GetSystemInfo ()
			
			{
				if (this.IsConnected)
				{
					this.SendCommand ("SYST");
					this.OnCommandCompleted ();
				}
			}
			
			public void Help (string CommandName)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("HELP " + CommandName));
					this.OnCommandCompleted ();
				}
			}
			
			public void Help ()
			
			{
				if (this.IsConnected)
				{
					this.SendCommand ("HELP");
					this.OnCommandCompleted ();
				}
			}
			
			private bool IsValidResponse (string Input)
			
			{
				char[] charArray1 = new char[] { '\n' };
				string[] stringArray1 = Input.Split (charArray1);
				if (stringArray1.Length > 1)
				{
					try
					{
						if (stringArray1[(stringArray1.Length - 2)].Replace ("\r", "").Substring (3, 1).Equals (" "))
						{
							return true;
						}
					}
					catch
					{
						return false;
					}
				}
				return false;
			}
			
			public void MakeDir (string DirectoryName)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("MKD " + DirectoryName));
					this.OnCommandCompleted ();
				}
			}
			
			private int MonthToNumber (string Input)
			
			{
				string string1;
				int i1;
				Dictionary<String, Int32> dictionary21 = ((Dictionary<String, Int32>) null);
				if ((string1 = Input.ToLower ()) != null)
				{
					if (dictionary21 == null)
					{
						dictionary21 = new Dictionary<String, Int32> (12);
						dictionary21.Add ("jan", 0);
						dictionary21.Add ("feb", 1);
						dictionary21.Add ("mar", 2);
						dictionary21.Add ("apr", 3);
						dictionary21.Add ("may", 4);
						dictionary21.Add ("jun", 5);
						dictionary21.Add ("jul", 6);
						dictionary21.Add ("aug", 7);
						dictionary21.Add ("sep", 8);
						dictionary21.Add ("oct", 9);
						dictionary21.Add ("nov", 10);
						dictionary21.Add ("dec", 11);
					}
					if (dictionary21.TryGetValue (string1, out i1))
					{
						switch (i1)
						{
							case 0:
							
							{
									return 1;
							}
							case 1:
							
							{
									return 2;
							}
							case 2:
							
							{
									return 3;
							}
							case 3:
							
							{
									return 4;
							}
							case 4:
							
							{
									return 5;
							}
							case 5:
							
							{
									return 6;
							}
							case 6:
							
							{
									return 7;
							}
							case 7:
							
							{
									return 8;
							}
							case 8:
							
							{
									return 9;
							}
							case 9:
							
							{
									return 10;
							}
							case 10:
							
							{
									return 11;
							}
							case 11:
							
							{
									return 12;
							}
						}
					}
				}
				return int.Parse (Input);
			}
			
			public void NoOperation ()
			
			{
				if (this.IsConnected)
				{
					this.SendCommand ("NOOP");
					this.OnCommandCompleted ();
				}
			}
			
			protected virtual void OnCommandCompleted ()
			
			{
				if (this.CommandCompleted != null)
				{
					this.CommandCompleted ();
				}
			}
			
			protected virtual void OnCommandSent (string Command)
			
			{
				if (this.CommandSent != null)
				{
					this.CommandSent (Command);
				}
			}
			
			protected virtual void OnConnected ()
			
			{
				if (this.Connected != null)
				{
					this.Connected ();
				}
			}
			
			protected virtual void OnConnectionFailed ()
			
			{
				if (this.ConnectionFailed != null)
				{
					this.ConnectionFailed ();
				}
			}
			
			protected virtual void OnDisconnected ()
			
			{
				if (this.Disconnected != null)
				{
					this.Disconnected ();
				}
			}
			
			protected virtual void OnNewDirectoryListing ()
			
			{
				if (this.NewDirectoryListing != null)
				{
					this.NewDirectoryListing ();
				}
			}
			
			protected virtual void OnReceivedReply (string Reply, short ReplyNumber, short ReplyType)
			
			{
				if (this.ReceivedReply != null)
				{
					this.ReceivedReply (Reply, ReplyNumber, ReplyType);
				}
			}
			
			private void ParseDirList (string DirList)
			
			{
				string[] stringArray2;
				DateTime dateTime1;
				string[] stringArray3;
				string string1;
				string[] stringArray4;
				FileItem[] fileItemArray1;
				string[] stringArray5;
				FileItem[] fileItemArray2;
				string[] stringArray6;
				string[] stringArray7;
				int i2;
				char[] charArray2;
				char[] charArray3;
				char[] charArray4;
				char[] charArray5;
				char[] charArray1 = new char[] { '\n' };
				string[] stringArray1 = DirList.Split (charArray1);
				this.remoteFileCount = 0;
				if (DirList == null)
				{
				}
				else
				{
					for (int i1 = 0; true; i1++)
					{
						if (i1 >= (stringArray1.Length - 1))
						{
							if ((this.remoteFiles != null) && (this.remoteFiles.Length > 0))
							{
								Array.Sort<FileItem> (this.remoteFiles);
							}
							return;
						}
						charArray2 = new char[] { '\u0020' };
						stringArray2 = this.RemoveRedundantItems (stringArray1[i1].Trim ().Split (charArray2));
						if (stringArray2.Length < 9)
						{
							if (stringArray2.Length > 4)
							{
								stringArray2[3] = string.Join (" ", stringArray2, 3, ((int) (stringArray2.Length - 3)));
								stringArray5 = new string[4];
								if (stringArray2 != null)
								{
									Array.Copy (((Array) stringArray2), ((Array) stringArray5), 4);
								}
								stringArray2 = stringArray5;
							}
							if (stringArray2.Length == 4)
							{
								fileItemArray2 = new FileItem[(this.remoteFileCount + 1)];
								if (this.remoteFiles != null)
								{
									Array.Copy (((Array) this.remoteFiles), ((Array) fileItemArray2), this.remoteFileCount);
								}
								this.remoteFiles = fileItemArray2;
								this.remoteFiles[this.remoteFileCount] = new FileItem ();
								this.remoteFiles[this.remoteFileCount].FileTitle = stringArray2[3];
								this.remoteFiles[this.remoteFileCount].FilePath = this.remoteDirectory;
								this.remoteFiles[this.remoteFileCount].IsDirectory = (stringArray2[2].CompareTo ("<DIR>") == 0);
								if (! this.remoteFiles[this.remoteFileCount].IsDirectory)
								{
									this.remoteFiles[this.remoteFileCount].FileSize = long.Parse (stringArray2[2]);
								}
								charArray4 = new char[] { '\u002D' };
								stringArray6 = stringArray2[0].Split (charArray4);
								charArray5 = new char[] { '\u003A' };
								stringArray7 = stringArray2[1].Split (charArray5);
								i2 = int.Parse (stringArray6[2]);
								dateTime1 = new DateTime (((i2 > 10) ? (1900 + i2) : (2000 + i2)), int.Parse (stringArray6[0]), int.Parse (stringArray6[1]), int.Parse (stringArray7[0]), int.Parse (stringArray7[1]), 0);
								this.remoteFiles[this.remoteFileCount].FileDate = dateTime1;
								this.remoteFileCount++;
							}
						}
						else
						{
							if (stringArray2.Length > 9)
							{
								stringArray2[8] = string.Join (" ", stringArray2, 8, ((int) (stringArray2.Length - 8)));
								stringArray4 = new string[9];
								if (stringArray2 != null)
								{
									Array.Copy (((Array) stringArray2), ((Array) stringArray4), 9);
								}
								stringArray2 = stringArray4;
							}
							if (stringArray2.Length == 9)
							{
								fileItemArray1 = new FileItem[(this.remoteFileCount + 1)];
								if (this.remoteFiles != null)
								{
									Array.Copy (((Array) this.remoteFiles), ((Array) fileItemArray1), this.remoteFileCount);
								}
								this.remoteFiles = fileItemArray1;
								this.remoteFiles[this.remoteFileCount] = new FileItem ();
								this.remoteFiles[this.remoteFileCount].FilePermissions = stringArray2[0].Substring (1);
								this.remoteFiles[this.remoteFileCount].FileOwner = stringArray2[2];
								this.remoteFiles[this.remoteFileCount].FileGroup = stringArray2[3];
								this.remoteFiles[this.remoteFileCount].FileSize = long.Parse (stringArray2[4]);
								if (stringArray2[7].IndexOf (":") >= 0)
								{
									charArray3 = new char[] { '\u003A' };
									stringArray3 = stringArray2[7].Split (charArray3);
									string1 = "2001";
								}
								else
								{
									stringArray3 = new string[] { "0", "0" };
									string1 = stringArray2[7];
								}
								dateTime1 = new DateTime (int.Parse (string1), this.MonthToNumber (stringArray2[5]), int.Parse (stringArray2[6]), int.Parse (stringArray3[0]), int.Parse (stringArray3[1]), 0);
								this.remoteFiles[this.remoteFileCount].FileDate = dateTime1;
								this.remoteFiles[this.remoteFileCount].FileTitle = stringArray2[8];
								this.remoteFiles[this.remoteFileCount].FilePath = this.remoteDirectory;
								this.remoteFiles[this.remoteFileCount].IsDirectory = (stringArray2[0].ToLower ()[0] == 'd');
								this.remoteFileCount++;
							}
						}
					}
				}
			}
			
			public void PrintWorkDir ()
			
			{
				int i2;
				if (! this.IsConnected)
				{
					return;
				}
				this.SendCommand ("PWD");
				int i1 = this.lastResponse.IndexOf ("\"");
				try
				{
					if (i1 >= 0)
					{
						i2 = this.lastResponse.IndexOf ("\"", ((int) (i1 + 1)));
						if (i2 >= 0)
						{
							this.remoteDirectory = this.lastResponse.Substring (((int) (i1 + 1)), ((int) ((i2 - i1) - 1)));
						}
						else
						{
							this.remoteDirectory = this.lastResponse.Substring (4);
						}
					}
					else
					{
						this.remoteDirectory = this.lastResponse.Substring (4);
					}
				}
				catch
				{
				}
				this.OnCommandCompleted ();
			}
			
			public void RemoveDir (string DirectoryName)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("RMD " + DirectoryName));
					this.OnCommandCompleted ();
				}
			}
			
			private string[] RemoveRedundantItems (string[] Input)
			
			{
				int i1;
				int i2 = 0;
				string[] stringArray1 = new string[Input.Length];
				for (i1 = 0; (i1 < Input.Length); i1++)
				{
					if (Input[i1] != "")
					{
						stringArray1[i2] = Input[i1];
						i2++;
					}
				}
				string[] stringArray2 = new string[i2];
				Array.Copy (((Array) stringArray1), ((Array) stringArray2), i2);
				return stringArray2;
			}
			
			public void Rename (string OriginalName, string NewName)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("RNFR " + OriginalName));
					if (this.lastResponseType == 3)
					{
						this.SendCommand (("RNTO " + NewName));
					}
					this.OnCommandCompleted ();
				}
			}
			
			private void SendCommand (string Command)
			
			{
				try
				{
					int i1 = this.clientSocket.Send (this.ASCII.GetBytes ((Command + "\r\n")));
					if ((Command.Length >= 4) && Command.Substring (0, 4).ToUpper ().Equals ("PASS"))
					{
						this.OnCommandSent ("PASS ********");
					}
					else
					{
						this.OnCommandSent (Command);
					}
					this.WaitForResponse ();
				}
				catch (Exception)
				{
					this.isNowConnected = false;
					this.OnConnectionFailed ();
					this.lastResponseNumber = 0;
					this.lastResponseType = 0;
					this.lastResponse = "";
					throw new SocketException ();
				}
			}
			
			public void SiteCommand (string Command)
			
			{
				if (this.IsConnected)
				{
					this.SendCommand (("SITE " + Command));
					this.OnCommandCompleted ();
				}
			}
			
			public void Status ()
			
			{
				if (this.IsConnected)
				{
					this.SendCommand ("STAT");
					this.OnCommandCompleted ();
				}
			}
			
			public void UploadDirectory (string path, bool recurse, string mask)
			
			{
				char[] charArray1 = new char[] { '\\' };
				string[] stringArray1 = path.Replace ("/", "\\").Split (charArray1);
				string string1 = stringArray1[(stringArray1.Length - 1)];
				this.MakeDir (string1);
				this.ChangeWorkDir (string1);
				foreach (string string2 in Directory.GetFiles (path, mask))
				{
					bool b1 = this.UploadFile (string2, Path.GetFileName (string2));
				}
				if (recurse)
				{
					foreach (string string3 in Directory.GetDirectories (path))
					{
						this.UploadDirectory (string3, recurse, mask);
					}
				}
				this.ChangeWorkDir ("..");
			}
			
			public bool UploadFile (string LocalFile, string RemoteFile, StreamModes StreamMode, DataConnection.FileModes FileMode, long AppendFrom)
			
			{
				IPEndPoint iPEndPoint1;
				string[] stringArray1;
				this.SendCommand (("TYPE " + Convert.ToChar (StreamMode).ToString ()));
				if (! this.CreateDataSocket (LocalFile, FileMode, DataConnection.StreamDirections.Upload, AppendFrom))
				{
					this.OnCommandCompleted ();
					return false;
				}
				else
				{
					if (! this.passiveTransfers)
					{
						iPEndPoint1 = this.dataSocket.GetLocalEndPoint;
						stringArray1 = new string[] { "PORT ", iPEndPoint1.Address.ToString ().Replace (".", ","), ",", ((int) Math.Floor (((double) (iPEndPoint1.Port / 256)))).ToString (), ",", (iPEndPoint1.Port % 256).ToString () };
						this.SendCommand (string.Concat (stringArray1));
					}
					if ((FileMode == DataConnection.FileModes.Append) && (AppendFrom > ((long) 0)))
					{
						this.SendCommand (("REST " + AppendFrom.ToString ()));
						this.SendCommand (("APPE " + RemoteFile));
					}
					else
					{
						this.SendCommand (("STOR " + RemoteFile));
					}
					if ((this.lastResponseType != 4) && (this.lastResponseType != 5))
					{
						try
						{
							this.dataSocket.SendToSocket ();
						}
						catch
						{
							this.dataSocket.Close ();
							this.WaitForResponse ();
							this.OnCommandCompleted ();
							return false;
						}
						this.WaitForResponse ();
					}
					this.dataSocket.Close ();
					this.OnCommandCompleted ();
					if (this.lastResponseType == 4)
					{
						return false;
					}
					else
					{
						return (this.lastResponseType != 5);
					}
				}
			}
			
			public bool UploadFile (string LocalFile, string RemoteFile, StreamModes StreamMode)
			
			{
				return this.UploadFile (LocalFile, RemoteFile, StreamMode, DataConnection.FileModes.Overwrite, 0L);
			}
			
			public bool UploadFile (string LocalFile, string RemoteFile)
			
			{
				return this.UploadFile (LocalFile, RemoteFile, StreamModes.Binary, DataConnection.FileModes.Overwrite, 0L);
			}
			
			public bool UploadFile (string LocalFile, string RemoteFile, DataConnection.FileModes FileMode, long AppendFrom)
			
			{
				return this.UploadFile (LocalFile, RemoteFile, StreamModes.Binary, FileMode, AppendFrom);
			}
			
			private void WaitForResponse ()
			
			{
				byte[] byteArray1;
				int i1;
				string string1;
				if (! this.isNowConnected)
				{
					return;
				}
				byteArray1 = new byte[1024];
				string1 = "";
				
			L_001A:
				
				{
				}
				try
				{
					i1 = this.clientSocket.Receive (byteArray1);
				}
				catch
				{
					goto L_004A;
				}
				string1 = (string1 + this.ASCII.GetString (byteArray1, 0, i1));
				if (! this.IsValidResponse (string1))
				{
					goto L_001A;
				}
				
			L_004A:
				
				{
				}
				this.lastResponse = string1;
				if (string1.Length >= 3)
				{
					this.lastResponseNumber = short.Parse (string1.Substring (0, 3));
				}
				else
				{
					this.lastResponseNumber = 0;
				}
				this.lastResponseType = ((short) Math.Floor (((double) (this.lastResponseNumber / 100))));
				this.OnReceivedReply (this.lastResponse, this.lastResponseNumber, this.lastResponseType);
			}
			
		#endregion
	}
	
}

