//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:24:48
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECSession

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Protocol;
			using System.Collections;
			using System;
			using System.IO;
			using System.Reflection;
			using System.Runtime.InteropServices;
			using System.Xml;
			
		#endregion
		
	[ComVisibleAttribute(false)]
	// [DefaultMemberAttribute("Item")]
	public sealed class AtJob
	
	{
		
		#region Fields
			private int cacheSize;
			private bool m_bEnableMOTF;
			private bool m_bExternalStart;
			private bool m_bOverwrite;
			private double m_dMarkSpeedStepPeriod;
			private int m_iExternalDebounce;
			private int m_iExternalPort;
			private uint m_iExternalStartTimeout;
			private int m_iMOTFWaitForCount;
			private int m_iTriggerMode;
			private ArrayList m_lstObjects;
			private AtCommand m_oFirstJumpAbs;
			private string m_strJobName;
		#endregion
		
		#region Constructors
		
			public AtJob ()
			
			{
				this.m_iTriggerMode = 3;
				this.m_strJobName = "";
				this.m_lstObjects = new ArrayList ();
			}
			
		#endregion
		
		#region Properties
		
			public int CacheSize
			
			{
				get
				{
					return this.cacheSize;
				}
				set
				{
					this.cacheSize = value;
				}
			}
			
			
			public bool EnableMOTF
			
			{
				get
				{
					return this.m_bEnableMOTF;
				}
				set
				{
					this.m_bEnableMOTF = value;
				}
			}
			
			
			public int ExternalPort
			
			{
				get
				{
					return this.m_iExternalPort;
				}
				set
				{
					this.m_iExternalPort = value;
				}
			}
			
			
			public bool ExternalStart
			
			{
				get
				{
					return this.m_bExternalStart;
				}
				set
				{
					this.m_bExternalStart = value;
				}
			}
			
			
			public int ExternalStartDebounce
			
			{
				get
				{
					return this.m_iExternalDebounce;
				}
				set
				{
					this.m_iExternalDebounce = value;
				}
			}
			
			
			public uint ExternalStartTimeout
			
			{
				get
				{
					return this.m_iExternalStartTimeout;
				}
				set
				{
					this.m_iExternalStartTimeout = value;
				}
			}
			
			
			public object this[int idx]
			
			{
				get
				{
					if ((idx > -1) && (idx < this.m_lstObjects.Count))
					{
						return this.m_lstObjects[idx];
					}
					else
					{
						throw new InvalidOperationException ("[AtJob.get_Item] Index out of range");
					}
				}
				set
				{
					if ((idx > -1) && (idx < this.m_lstObjects.Count))
					{
						this.m_lstObjects[idx] = value;
					}
					else if (idx == this.m_lstObjects.Count)
					{
						int i1 = this.m_lstObjects.Add (value);
					}
					else
					{
						throw new InvalidOperationException ("[AtJob.set_Item] Index out of range");
					}
				}
			}
			
			
			public string JobName
			
			{
				get
				{
					return this.m_strJobName;
				}
				set
				{
					this.m_strJobName = value;
				}
			}
			
			
			public double MarkSpeedStepPeriod
			
			{
				get
				{
					return this.m_dMarkSpeedStepPeriod;
				}
				set
				{
					this.m_dMarkSpeedStepPeriod = value;
				}
			}
			
			
			public int MOTFWaitForCount
			
			{
				get
				{
					return this.m_iMOTFWaitForCount;
				}
				set
				{
					this.m_iMOTFWaitForCount = value;
				}
			}
			
			
			public bool Overwrite
			
			{
				get
				{
					return this.m_bOverwrite;
				}
				set
				{
					this.m_bOverwrite = value;
				}
			}
			
			
			public int Size
			
			{
				get
				{
					int i1 = 0;
					foreach (AtObject atObject1 in this.m_lstObjects)
					{
						i1 += atObject1.Size;
					}
					return ((i1 + AtCommand.OpcodeSize (LECOpcodes.BeginJob)) + AtCommand.OpcodeSize (LECOpcodes.EndJob));
				}
			}
			
			
			public int TriggerMode
			
			{
				get
				{
					return this.m_iTriggerMode;
				}
				set
				{
					this.m_iTriggerMode = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public int Add (AtObject poObject)
			
			{
				return this.m_lstObjects.Add (poObject);
			}
			
			public void Clear ()
			
			{
				this.m_lstObjects.Clear ();
			}
			
			private bool DrawListFromXML (LECOpcodes oCmd, ref XmlTextReader xmlRead, ref AtObject oObject)
			
			{
				string[] stringArray1;
                char[] charArray1 = new char[] { ' ' };
				ArrayList arrayList1 = new ArrayList ();
				for (stringArray1 = ((string[]) null); xmlRead.Read (); stringArray1 = xmlRead.Value.Split (charArray1))
				{
					if (xmlRead.NodeType != XmlNodeType.Text)
					{
						if (xmlRead.NodeType == XmlNodeType.EndElement)
						{
							if (xmlRead.Name.ToLower ().CompareTo ("vertex") != 0)
							{
								if (xmlRead.Name.ToLower ().CompareTo ("draw") == 0)
								{
									break;
								}
								continue;
							}
							int i1 = arrayList1.Add (stringArray1[0]);
							int i2 = arrayList1.Add (stringArray1[1]);
						}
						continue;
					}
					charArray1 = new char[] { '\u002C' };
				}
				if (arrayList1.Count == 0)
				{
					return false;
				}
				AtCommand atCommand1 = new AtCommand (oCmd, arrayList1);
				int i3 = oObject.Add (atCommand1);
				return true;
			}
			
			public bool FromXML (string pstrData)
			
			{
				StringReader stringReader1;
				XmlTextReader xmlTextReader1;
				AtObject atObject1;
				bool b1;
				bool b2;
				string string1;
				LECOpcodes lECOpcodes1;
				uint uInt32_1;
				uint uInt32_2;
				string[] stringArray1;
				AtCommand atCommand1;
				AtCommand atCommand2;
				char[] charArray1;
				stringReader1 = new StringReader (pstrData);
				xmlTextReader1 = new XmlTextReader (((TextReader) stringReader1));
				atObject1 = new AtObject ();
				b1 = false;
				b2 = xmlTextReader1.Read ();
				goto L_01D5;
				
			L_01CD:
				
				{
				}
				b2 = xmlTextReader1.Read ();
				
			L_01D5:
				
				{
				}
				while (b2)
				{
					if (xmlTextReader1.NodeType == XmlNodeType.Element)
					{
						if (xmlTextReader1.Name.CompareTo ("Data") != 0)
						{
							if (b1)
							{
								string1 = xmlTextReader1.Name;
								if (string1.ToLower ().CompareTo ("set") == 0)
								{
									string1 = ("Set" + xmlTextReader1.GetAttribute ("id"));
								}
								lECOpcodes1 = AtCommand.ToOpcode (string1);
								if (lECOpcodes1 == LECOpcodes.Unknown)
								{
									xmlTextReader1.Close ();
									stringReader1.Close ();
									return false;
								}
								if (lECOpcodes1 == LECOpcodes.OutputDrawList)
								{
									if (this.DrawListFromXML (lECOpcodes1, ref xmlTextReader1, ref atObject1))
									{
										continue;
									}
									else
									{
										xmlTextReader1.Close ();
										stringReader1.Close ();
										return false;
									}
								}
								if (lECOpcodes1 == LECOpcodes.SetWobble)
								{
									if (this.WobbleFromXML (lECOpcodes1, ref xmlTextReader1, ref atObject1))
									{
										continue;
									}
									else
									{
										xmlTextReader1.Close ();
										stringReader1.Close ();
										return false;
									}
								}
								uInt32_1 = AtCommand.ParameterCount (lECOpcodes1);
								uInt32_2 = AtCommand.ParameterMinCount (lECOpcodes1);
								stringArray1 = ((string[]) null);
								if ((uInt32_1 != uint.MinValue) || (uInt32_2 != uint.MinValue))
								{
									while (xmlTextReader1.Read ())
									{
										if (xmlTextReader1.NodeType != XmlNodeType.Text)
										{
											if (xmlTextReader1.NodeType == XmlNodeType.EndElement)
											{
												break;
											}
											continue;
										}
										charArray1 = new char[] { '\u002C' };
										stringArray1 = xmlTextReader1.Value.Split (charArray1);
										break;
									}
								}
								if (stringArray1 == null)
								{
									atCommand1 = new AtCommand (lECOpcodes1);
									int i1 = atObject1.Add (atCommand1);
									goto L_01CD;
								}
								if ((((uint) stringArray1.Length) < uInt32_2) || (((uint) stringArray1.Length) > uInt32_1))
								{
									xmlTextReader1.Close ();
									stringReader1.Close ();
									return false;
								}
								if (lECOpcodes1 == LECOpcodes.SetMarkSpeed)
								{
									this.m_dMarkSpeedStepPeriod = Convert.ToDouble (stringArray1[0]);
								}
								atCommand2 = new AtCommand (lECOpcodes1, stringArray1);
								int i2 = atObject1.Add (atCommand2);
							}
							goto L_01CD;
						}
						if (xmlTextReader1.GetAttribute ("type").CompareTo ("JobData") != 0)
						{
							xmlTextReader1.Close ();
							stringReader1.Close ();
							return false;
						}
						b1 = true;
					}
					goto L_01CD;
				}
				int i3 = this.Add (atObject1);
				xmlTextReader1.Close ();
				stringReader1.Close ();
				return true;
			}
			
			public ArrayList ToBeginJobCommands ()
			
			{
				AtCommand atCommand1;
				short int16_1;
				ArrayList arrayList1 = new ArrayList ();
				this.m_oFirstJumpAbs = ((AtCommand) null);
				if (this.ExternalStart)
				{
					atCommand1 = new AtCommand (LECOpcodes.WriteDigital, 0, 1);
					int i1 = arrayList1.Add (atCommand1);
					int16_1 = ((short) (this.TriggerMode * 256));
					int16_1 += ((short) this.ExternalPort);
					atCommand1 = new AtCommand (LECOpcodes.WaitForIO, int16_1, this.ExternalStartTimeout, ((uint) this.ExternalStartDebounce));
					int i2 = arrayList1.Add (atCommand1);
					atCommand1 = new AtCommand (LECOpcodes.WriteDigital, 0, 0);
					int i3 = arrayList1.Add (atCommand1);
				}
				atCommand1 = new AtCommand (LECOpcodes.BeginJob);
				int i4 = arrayList1.Add (atCommand1);
				if (this.EnableMOTF)
				{
					atCommand1 = new AtCommand (LECOpcodes.EnableMotf, 1);
					int i5 = arrayList1.Add (atCommand1);
				}
				if (this.MOTFWaitForCount != 0)
				{
					atCommand1 = new AtCommand (LECOpcodes.WaitForMotfCount, 0, this.MOTFWaitForCount);
					int i6 = arrayList1.Add (atCommand1);
				}
				return arrayList1;
			}
			
			public byte[] ToBytes ()
			
			{
				return this.ToBytes (this.ToCommands ());
			}
			
			public byte[] ToBytes (ArrayList plstCommands)
			
			{
				byte[] byteArray1;
				int i1 = 0;
				ArrayList arrayList1 = new ArrayList ();
				foreach (AtCommand atCommand1 in plstCommands)
				{
					byteArray1 = atCommand1.ToBytes ();
					i1 += byteArray1.Length;
					int i3 = arrayList1.Add (byteArray1);
				}
				byte[] byteArray2 = new byte[i1];
				int i2 = 0;
				foreach (byte[] byteArray3 in arrayList1)
				{
					Array.Copy (((Array) byteArray3), 0, ((Array) byteArray2), i2, byteArray3.Length);
					i2 += byteArray3.Length;
				}
				return byteArray2;
			}
			
			public ArrayList ToCommands ()
			
			{
				ArrayList arrayList1 = new ArrayList ();
				foreach (AtObject atObject1 in this.m_lstObjects)
				{
					arrayList1.InsertRange (arrayList1.Count, ((ICollection) atObject1.ToCommands ()));
				}
				if (this.m_oFirstJumpAbs == null)
				{
					foreach (AtCommand atCommand1 in arrayList1)
					{
						if (atCommand1.Opcode == LECOpcodes.JumpAbs)
						{
							this.m_oFirstJumpAbs = atCommand1;
							break;
						}
					}
				}
				return arrayList1;
			}
			
			public ArrayList ToEndJobCommands ()
			
			{
				AtCommand atCommand1;
				ArrayList arrayList1 = new ArrayList ();
				if (this.EnableMOTF && (this.m_oFirstJumpAbs != null))
				{
                    //atCommand1 = new AtCommand(LECOpcodes.MotfResetJump, ((short) this.m_oFirstJumpAbs.Parameters[0]), ((short) this.m_oFirstJumpAbs.Parameters[1]), ((short) this.m_oFirstJumpAbs.Parameters[2]), ((short) this.m_oFirstJumpAbs.Parameters[5]), 0);
                    atCommand1 = new AtCommand(LECOpcodes.MotfResetJump, ((short)this.m_oFirstJumpAbs.Parameters[0]), ((short)this.m_oFirstJumpAbs.Parameters[1]), ((short)this.m_oFirstJumpAbs.Parameters[2]), ((short)this.m_oFirstJumpAbs.Parameters[5]), (short)0);
                    int i1 = arrayList1.Add(atCommand1);
				}
				atCommand1 = new AtCommand (LECOpcodes.EndJob);
				int i2 = arrayList1.Add (atCommand1);
				return arrayList1;
			}
			
			private bool WobbleFromXML (LECOpcodes oCmd, ref XmlTextReader xmlRead, ref AtObject oObject)
			
			{
				string[] stringArray1;
				double double2;
				double double3;
				short int16_1;
				int i1;
				short int16_2;
                char[] charArray1 = new char[] {' '};
				if (0D == this.m_dMarkSpeedStepPeriod)
				{
					return false;
				}
				double double1 = 0.0061359231515425647D;
				short[] int16Array1 = new short[257];
				for (stringArray1 = ((string[]) null); xmlRead.Read (); stringArray1 = xmlRead.Value.Split (charArray1))
				{
					if (xmlRead.NodeType != XmlNodeType.Text)
					{
						if (xmlRead.NodeType != XmlNodeType.EndElement)
						{
							continue;
						}
						if (stringArray1 == null)
						{
							return false;
						}
						if (xmlRead.Name.ToLower ().CompareTo ("set") != 0)
						{
							return false;
						}
						double2 = Convert.ToDouble (stringArray1[0]);
						double3 = Convert.ToDouble (stringArray1[1]);
						int16_1 = Convert.ToInt16 ((256D / (((double2 / 1000000D) / 4D) / (this.m_dMarkSpeedStepPeriod / 1000000D))));
						int16Array1[0] = int16_1;
						for (i1 = 0; (i1 < 256); i1++)
						{
							int16_2 = Convert.ToInt16 ((Math.Sin ((double1 * ((double) i1))) * double3));
							int16Array1[(i1 + 1)] = int16_2;
						}
						break;
					}
					charArray1 = new char[] { '\u002C' };
				}
				if (stringArray1 == null)
				{
					return false;
				}
				AtCommand atCommand1 = new AtCommand (oCmd, int16Array1, 257);
				int i2 = oObject.Add (atCommand1);
				return true;
			}
			
		#endregion
	}
	
}

