//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 10:24:48
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECSession

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System;
			using System.IO;
			using System.Net;
			using System.Net.Sockets;
			using System.Runtime.InteropServices;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	[ComVisibleAttribute(false)]
	internal class LECAliveThread : BaseThread
	
	{
		
		#region Fields
			private AtAlive aliveData;
			private int heartbeatPeriod;
			private uint heartbeatRetry;
			private long lastTimeTick;
			private string localIPAddress;
			private bool m_bInterrupted;
			public event ConnectionNotify OnConnectionNotify;
			private string remoteIPAddress;
			private int remoteIPPort;
			private TcpClient tcpAliveChannel;
			private NetworkStream tcpAliveStream;
			private TransmitPacket transmitData;
		#endregion
		
		#region Constructors
		
			public LECAliveThread (string localAddress, string remoteAddress, int remotePort, uint heartbeatTimeout, int heartbeatPeriod)
			
			{
				this.localIPAddress = "";
				this.remoteIPAddress = "";
				this.lastTimeTick = (DateTime.Now.Ticks / ((long) 10000000));
				this.localIPAddress = localAddress;
				this.remoteIPAddress = remoteAddress;
				this.remoteIPPort = remotePort;
				this.RetryTime = heartbeatTimeout;
				this.HeartbeatPeriod = heartbeatPeriod;
				base.ChildTerminateWait = 0;
			}
			
		#endregion
		
		#region Properties
		
			public int HeartbeatPeriod
			
			{
				get
				{
					return this.heartbeatPeriod;
				}
				set
				{
					this.heartbeatPeriod = value;
				}
			}
			
			
			protected bool Interrupted
			
			{
				get
				{
					return this.m_bInterrupted;
				}
				set
				{
					this.m_bInterrupted = value;
				}
			}
			
			
			public long LastTimeTick
			
			{
				get
				{
					return this.lastTimeTick;
				}
				set
				{
					this.lastTimeTick = value;
				}
			}
			
			
			public uint RetryTime
			
			{
				get
				{
					return this.heartbeatRetry;
				}
				set
				{
					this.heartbeatRetry = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void Dispose ()
			
			{
				if (this.tcpAliveStream != null)
				{
					this.tcpAliveStream.Close ();
					this.tcpAliveStream = ((NetworkStream) null);
				}
				if (this.tcpAliveChannel != null)
				{
					this.tcpAliveChannel.Close ();
					this.tcpAliveChannel = ((TcpClient) null);
				}
			}
			
			protected override bool ExecuteWorkThread ()
			
			{
				byte[] byteArray1;
				int i1;
				byte[] byteArray2;
				byte[] byteArray3;
				long int64_1;
				try
				{
					Logging.Instance.Log (4, "LECAlive.ExecuteWorkThread() - Start Executing Work.");
					if (this.Interrupted)
					{
						this.Interrupted = false;
						return true;
					}
					else if (this.tcpAliveStream == null)
					{
						return false;
					}
					else
					{
						this.aliveData.Enable = true;
						this.aliveData.RetryTime = this.RetryTime;
						byteArray1 = this.aliveData.ToBytes ();
						i1 = 0;
						while (i1 < this.HeartbeatPeriod)
						{
							Thread.Sleep (1000);
							if (! this.Interrupted)
							{
								i1++;
								continue;
							}
							this.Interrupted = false;
							return true;
						}
						if (this.tcpAliveStream.CanWrite)
						{
							this.transmitData.Address = IPAddress.Parse ("127.0.0.1");
							this.transmitData.RequestAddress = IPAddress.Parse ("127.0.0.1");
							this.transmitData.Opcode = 3;
							this.transmitData.DataSize = ((uint) byteArray1.Length);
							this.transmitData.Data = byteArray1;
							byteArray2 = this.transmitData.ToBytes ();
							this.tcpAliveStream.Write (byteArray2, 0, byteArray2.Length);
							if (! this.tcpAliveStream.CanRead)
							{
								return false;
							}
							else
							{
								if (this.tcpAliveStream.DataAvailable)
								{
									this.LastTimeTick = (DateTime.Now.Ticks / ((long) 10000000));
									byteArray3 = new byte[4];
									int i2 = this.tcpAliveStream.Read (byteArray3, 0, byteArray3.Length);
									Logging.Instance.Log (4, "LECAlive.ExecuteWorkThread() - Read {0} bytes.", byteArray3.Length);
								}
								int64_1 = (DateTime.Now.Ticks / ((long) 10000000));
								if ((int64_1 - this.LastTimeTick) >= ((long) this.RetryTime))
								{
									Logging.Instance.Log ("LECAlive.ExecuteWorkThread() - No packet received within timeout period. Abort.");
									return false;
								}
							}
						}
						else
						{
							return false;
						}
					}
				}
				catch (Exception)
				{
					Logging.Instance.Log ("LECAlive.ExecuteWorkThread() - Exception thrown. Abort.");
					return false;
				}
				return true;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				IPEndPoint iPEndPoint1;
				LingerOption lingerOption1;
				try
				{
					if ((this.localIPAddress == "0.0.0.0") || (this.localIPAddress == ""))
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Any, 0);
					}
					else
					{
						iPEndPoint1 = new IPEndPoint (IPAddress.Parse (this.localIPAddress), 0);
					}
					this.tcpAliveChannel = new TcpClient (iPEndPoint1);
					this.tcpAliveChannel.Connect (this.remoteIPAddress, this.remoteIPPort);
					lingerOption1 = new LingerOption (false, 1);
					this.tcpAliveChannel.LingerState = lingerOption1;
					this.aliveData = new AtAlive ();
					this.transmitData = new TransmitPacket ();
					this.tcpAliveStream = this.tcpAliveChannel.GetStream ();
					this.OnConnectionNotify (this.remoteIPAddress, true);
				}
				catch (Exception)
				{
					this.Dispose ();
					return false;
				}
				return base.InitializeWorkThread ();
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				this.Interrupted = true;
				base.InterruptWorkThread (pbAbort);
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				this.OnConnectionNotify (this.remoteIPAddress, false);
				this.Dispose ();
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

